#ifndef WCSP_DEFINITION
#define WCSP_DEFINITION
#include "regConstYices.h"
#include <vector>
#include <set>
#include <yices_c.h>
#include <string>
#include <vector>
#include <map>
#include <sstream>
#include <stdio.h>
#include <iostream>
#include <stdlib.h>

extern int d_debug;

//ycs_rcpsp

class ycs_rcpsp;


// #include "preprocessing.h"

using namespace std;

class WCSP {
 private:

  yices_context ctx;
  ycs_rcpsp *y;
  string solver;
  long maximalCost;
  long initialCost;
  long optim;
  bool eqOne; 
// int level;
  string cod;
  bool verbose;
  int ntasques;
  


  long optimtotal;

  //dicotomic
  long totalWeight;
  vector<yices_expr> vecConstraintsProtect;

  //pm1
  long contBStore;
  map<long,regConstYices> mapConstratintsStore;

  //yices
  long contWeithedYices;
  
  //pm2 and pm3
  vector<yices_expr> vecConstraints2;
  vector<long> vecWeigths2;
  vector<bool> vecDown2;
  set<long> setWeigths2;
  bool rcpspmax;
 
 public:	
  WCSP();
  void setContext(yices_context & c,string s,bool eqo,int sup, string codi,bool rcpspm,bool verb,ycs_rcpsp *b);
  void imprimir();
  void addConstraint(yices_expr e,long w);
  assertion_id addConstraintRet(yices_expr e);
  void delConstraintRet(assertion_id id);
  void solve(bool model,int vMin,int vMax,map<string,yices_var_decl> & mapDeclVar);
  void setMaximalCost(long maximalCost);
  void setInitialCost(long initialCost);
  ~WCSP();
  
  int typeSupport;
  int nbVariables;


 private:

  yices_expr reifVariable(yices_expr eb,long i);

  lbool dicotomic(bool model,int vMin);
  lbool dico2(bool model,int vMin);
  lbool pm1(int type,long wMax,int vMin);
  lbool pm12(int vMin);
  lbool pm13(int vMin);
  lbool pm3();
  lbool yices();
  lbool standard(bool model,int vMin,int vMax,map<string,yices_var_decl> & mapDeclVar);
  lbool standard2(bool model,int vMin,int vMax,map<string,yices_var_decl> & mapDeclVar);
  lbool linealup(bool model,int vMin,int vMax,map<string,yices_var_decl> & mapDeclVar);
  lbool linealdown(bool model,int vMin,int vMax,map<string,yices_var_decl> & mapDeclVar);
  lbool downConstraints(long wMax);
  lbool downConstraints3(long wMax);
  void addConstraintProtect(yices_expr e,long w);
  void addConstraintStore(yices_expr e,long w);
  void addConstraintStore2(yices_expr e,long w);
  void addConstraintYices(yices_expr e,long w);
  long updatePm1(int type,long core,assertion_id v[],long wMax);
  void atEqOne(vector<yices_expr> & vecProtect);
  void atMostOne(vector<yices_expr> & vecProtect);
  void atLeastOne(vector<yices_expr> & vecProtect);
  void escriure_starts(yices_model m);
};

#endif

