#include "yices_c.h"
#include "tasca.h"
#include "ycs_rcpsp.h"
#include "WCSP.h"
#include "rcpsp.h"
#include <string.h>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

int d_debug; 
int d_shmodel;

using namespace std;

void tractarYices(rcpsp p,bool model,string codificacio){
  
  yices_enable_log_file	("log.txt");
  
  yices_context ctx=yices_mk_context();
  ycs_rcpsp y;
  yices_expr e;
  WCSP w;
  
  y.setcontext(ctx);


  w.setContext(ctx,"standard",true,1,"Time",true,false,&y);
  y.inicialitzacions_comuns(p,w);
  // cout<<"\n"<< " VULL ENTRAR A CODIFICACIO TIME "<<"\n";
  //p.mostraMatriuDistMinimes();
  
  if (codificacio=="time") y.codificacioTime();
  else if (codificacio=="task") y.codificacioTask();
  else cout<<"\n"<<"PROBLEMES AMB LA CODIFICACIO"<<"\n"<<"\n";
  y.solucionar(model);
  //if (d_shmodel) y.mostraResultats();  
  y.delcontext(); 
}

// MAIN 
int main(int argc, char *argv[]) { 
  
  int i,j,w,trobat;
  bool inc;
  rcpsp p;
  ifstream f;
    
  string str1="rcp";
  string str2="sch";
  string str3="sm";
  string str4="pat";
  string str5="data";
  string str11="RCP";
  string str21="SCH";
  string str31="SM";
  string str41="PAT";
  string str51="DATA";  
  string cnv="-convert";
  string model_on="-model";    
  string show_out="-sdebug";
  string show_model="-shmodel"; 
  string cod_time="-time";
  string cod_task="-task";
  
  string bufp,aux,codificacio;
  size_t found,found2;  
  bool nrm,nrm2,model;
  
  
  trobat=0;
  d_debug=0;               
  d_shmodel=0;
  model=false;        

  for (i = 1; i < argc; i++){
    
    if (argv[i]==model_on) model=true;              

    if (argv[i]==show_out) d_debug=1;  
    
    if (argv[i]==cod_time) codificacio="time";
    
    if (argv[i]==cod_task) codificacio="task";
    
    if (argv[i]==show_model) d_shmodel=1; 
    
    if (argv[i]==cnv){
      trobat=1;
      i++;
      aux=argv[i];
    }
    else{
      
      f.open(argv[i],fstream::in | fstream::out | fstream::app);
      if (f==NULL) { printf("No es pot obrir el fitxer\n");}

      bufp = argv[i];
      // cout<<"Contingut del buffer...\t"<<bufp<<endl;
      found=bufp.find(str1);
      found2=bufp.find(str11);
      if ((found!=string::npos)||(found2!=string::npos))   {p.obtenir_dades_rcp(f);}  // Fitxer .rcp
      found=bufp.find(str2);
      found2=bufp.find(str21);
      if ((found!=string::npos)||(found2!=string::npos))   {p.obtenir_dades_sch(f);}  // Fitxer .sch
      found=bufp.find(str3);
      found2=bufp.find(str31);
      if ((found!=string::npos)||(found2!=string::npos))   {p.obtenir_dades_sm(f);}   // Fitxer .sm
      found=bufp.find(str4);
      found2=bufp.find(str41);
      if ((found!=string::npos)||(found2!=string::npos))   {p.obtenir_dades_pat(f);}  // Fitxer .pat  
      found=bufp.find(str5);
      found2=bufp.find(str51);
      if ((found!=string::npos)||(found2!=string::npos))   {p.obtenir_dades_data(f);} // Fitxer .data
      f.close();
    } //end_else      
  }   //end_for
       
   if (trobat) {
    if ((aux==str1)||(aux==str1))  p.convert2rcp();
    if ((aux==str2)||(aux==str21)) p.convert2sch();  
    if ((aux==str3)||(aux==str31)) p.convert2sm(bufp);
    if ((aux==str4)||(aux==str41)) p.convert2pat();
    if ((aux==str5)||(aux==str51)) p.convert2data();
   } 
 
 
 //----------------------------------------------------------------------------------
 
  p.omplirMatriuDist();
  if (d_debug) p.mostraArestes();
  //return(0);
  p.tractaGraf();
  //return(0);
  if (d_debug) p.mostraArestes();     // mostro les arestes si per consola passo per paràmetre -sdebug
  p.calculIncompatibilitats();
  tractarYices(p,model,codificacio);  
  
  return 0;
}           

