
#ifndef TAD_YCS_RCPSP
#define TAD_YCS_RCPSP
#include "yices_c.h"
#include "rcpsp.h"
#include "tasca.h"
#include "WCSP.h"
#include <iostream>
#include <string.h>
#include <map>
#include <fstream>
#include <vector>
#include <stdio.h>
#include <stdlib.h>

extern int d_debug;

using namespace std;

//class ycs_rcpsp : public rcpsp // aplico HERENCIA
class ycs_rcpsp
{
  yices_context ctx;
  int durada_tasques;       // còpia de la durada total de tasques del objecte rcpsp
  int n_tasques;            // còpia del nº de tasques del objecte rcpsp
  int n_recursos;           // còpia del nº de recursos del objecte rcpsp 
  vector<tasca> vec_tascas; // vector de tasques còpia del vector de tasques del objecte rcpsp
  vector<int>   vec_cpts;   // vector de capacitats còpia del vector de capacitats del objecte rcpsp
  int **distmin;     // Matriu distàncies interna on copio la distmin del objecte rcpsp
                     // E* -> matriu d'incompatibilitats 
  bool **incompatibles;
  map<string,yices_var_decl> mapDeclVar;
  map<string,yices_expr> mapExpVar;
  map<string,long> mapVarVal;
  map<string,string> mapVarType;     // depenent de si la variable es un int o bool emmagatzemaré l'string "int" o "bool"  
  WCSP w;
     
  void preProces1();
 
 public:
    
    ycs_rcpsp();
    void setcontext(yices_context c);
    yices_context getcontext();
    void inicialitzacions_comuns(rcpsp p, WCSP w);
    void codificacioTime();
    void codificacioTask();
    void crearVariable(string nom,string tipus);
    void ycs_mostrar(yices_expr e, string str="");
    yices_expr ycs_num(int dist_min);
    yices_expr ycs_boolea(bool valor);
    yices_expr ycs_sum(vector<yices_expr> v);
    yices_expr ycs_sub(vector<yices_expr> v);
    yices_expr ycs_mul(vector<yices_expr> v);
    yices_expr ycs_ge(yices_expr e1,yices_expr e_s_j);   // e1>=e_s_j
    yices_expr ycs_gt(yices_expr e1,yices_expr e2);      // e1>e2  
    yices_expr ycs_le(yices_expr e1,yices_expr e2);      // e1<=e2
    yices_expr ycs_lt(yices_expr e1,yices_expr e2);      // e1<e2
    yices_expr ycs_equal(yices_expr e1,yices_expr e2);   // e1=e2
    yices_expr ycs_ite(yices_expr e1,yices_expr e2,yices_expr e3); // if e1 llavors e2 else e3
    yices_expr ycs_and(vector<yices_expr> vectexpr);
    yices_expr ycs_or(vector<yices_expr> vectexpr);
    yices_expr ycs_not(yices_expr a);
    void calcular_upperbound(int ntasques,vector<tasca> vec_tascas);
    void crearTimeWindow(rcpsp p,yices_expr e1,int n_t);
    string int2str(int i);
    void afegirConstraint(yices_expr e1, int p=0);
    void solucionar(bool model);
    long buscaValor(yices_context c, string st, yices_var_decl v);
    void recupera();
    void mostraResultats();
    void delcontext();
};

#endif

